## lcm 1.3.1+repack1

=== test/Makefile ===
all:
	$(MAKE) -C gtest
	$(MAKE) -C c
	$(MAKE) -C cpp
	$(MAKE) -C python
	$(MAKE) -C java
	$(MAKE) -C lua

test: all
	./run_client_server_tests.py
	./run_unit_tests.py

clean:
	$(MAKE) -C gtest clean
	$(MAKE) -C c clean
	$(MAKE) -C cpp clean
	$(MAKE) -C java clean
	$(MAKE) -C python clean
	$(MAKE) -C lua clean

=== examples/c/Makefile ===
# This Makefile was tested with GNU Make
CC=gcc

# Use pkg-config to lookup the proper compiler and linker flags for LCM
CFLAGS=`pkg-config --cflags lcm`
LDFLAGS=`pkg-config --libs lcm`

all: listener \
	listener-async \
	send-message \
	read-log 

listener: exlcm_example_t.o listener.o
	$(CC) -o $@ $^ $(LDFLAGS)

listener-async: exlcm_example_t.o listener-async.o 
	$(CC) -o $@ $^ $(LDFLAGS)

listener-glib: exlcm_example_t.o listener-glib.o 
	$(CC) -o $@ $^ $(LDFLAGS)

send-message: exlcm_example_t.o send_message.o 
	$(CC) -o $@ $^ $(LDFLAGS)

read-log: exlcm_example_t.o read_log.o 
	$(CC) -o $@ $^ $(LDFLAGS)

# prevent auto-generated lcm .c/.h files from being deleted
.SECONDARY : exlcm_example_t.c exlcm_example_t.h

%.o: %.c %.h
	$(CC) $(CFLAGS) -c $< 

exlcm_%.c exlcm_%.h: ../types/%.lcm
	lcm-gen -c $<

clean:
	rm -f listener listener-async listener-glib send-message read-log
	rm -f *.o
	rm -f exlcm_example_t.c exlcm_example_t.h

=== examples/cpp/Makefile ===
# This Makefile was tested with GNU Make
CXX=g++

# Use pkg-config to lookup the proper compiler and linker flags for LCM
CFLAGS=`pkg-config --cflags lcm`
LDFLAGS=`pkg-config --libs lcm`

msg_types=../lcm/*.lcm

all: exlcm/example_t.hpp exlcm/example_list_t.hpp \
	listener \
	send-message \
	read-log

listener: listener.o 
	$(CXX) -o $@ $^ $(LDFLAGS)

send-message: send_message.o
	$(CXX) -o $@ $^ $(LDFLAGS)

read-log: read_log.o
	$(CXX) -o $@ $^ $(LDFLAGS)

%.o: %.cpp exlcm/example_t.hpp
	$(CXX) $(CFLAGS) -I. -o $@ -c $< 

exlcm/%.hpp:
	lcm-gen -x ../types/*.lcm

clean:
	rm -f listener send-message read-log
	rm -f *.o exlcm/*.o
	rm -f exlcm/*.hpp

=== test/c/Makefile ===
# This Makefile was tested with GNU Make
CC=gcc
LCM_GEN=../../lcmgen/lcm-gen

# Use pkg-config to lookup the proper compiler and linker flags for LCM
CFLAGS=`pkg-config --cflags lcm` -I../gtest/include -std=c99 -g
CXXFLAGS=`pkg-config --cflags lcm` -I../gtest/include -g
LDFLAGS=`pkg-config --libs lcm`
GTEST_LIBS=../gtest/libgtest.a ../gtest/libgtest_main.a

types1:=exampleconst_t primitives_t primitives_list_t multidim_array_t node_t comments_t
types2:=another_type_t cross_package_t
types_obj:=$(types1:%=lcmtest_%.o) $(types2:%=lcmtest2_%.o)
types_src:=$(types1:%=lcmtest_%.c) $(types1:%=lcmtest_%.h) $(types2:%=lcmtest2_%.c) $(types2:%=lcmtest2_%.h)

all: server \
	client \
	memq_test \
	eventlog_test \
	udpm_test

server: server.o common.o $(types_obj)
	echo $(types_obj)
	$(CC) -o $@ $^ $(LDFLAGS)

client: client.o common.o $(types_obj)
	$(CXX) -o $@ $^ $(LDFLAGS) $(GTEST_LIBS)

common.o: common.c $(types_src)
	$(CC) $(CFLAGS) -c $<

client.o: client.cpp $(types_src)
	$(CXX) $(CXXFLAGS) -c $<

server.o: server.c $(types_src)
	$(CC) $(CFLAGS) -c $<

eventlog_test: eventlog_test.o common.o
	$(CXX) -o $@ $^ $(LDFLAGS) $(GTEST_LIBS)

eventlog_test.o: eventlog_test.cpp
	$(CXX) $(CXXFLAGS) -c $<

memq_test: memq_test.o
	$(CXX) -o $@ $^ $(LDFLAGS) $(GTEST_LIBS)

memq_test.o: memq_test.cpp $(types_src)
	$(CXX) $(CXXFLAGS) -c $<

udpm_test: udpm_test.o
	$(CXX) -o $@ $^ $(LDFLAGS) $(GTEST_LIBS)

udpm_test.o: udpm_test.cpp $(types_src)
	$(CXX) $(CXXFLAGS) -c $<

lcmtest_%.o: lcmtest_%.c lcmtest_%.h
	$(CC) $(CFLAGS) -c $<

lcmtest_%.c lcmtest_%.h: ../types/lcmtest/%.lcm
	$(LCM_GEN) -c $<

lcmtest2_%.c lcmtest2_%.h: ../types/lcmtest2/%.lcm
	$(LCM_GEN) -c $<

clean:
	rm -f client server
	rm -f memq_test eventlog_test
	rm -f $(types_src)
	rm -f *.o

=== test/cpp/Makefile ===
# This Makefile was tested with GNU Make
CC=g++
LCM_GEN=../../lcmgen/lcm-gen

# Use pkg-config to lookup the proper compiler and linker flags for LCM
CFLAGS=`pkg-config --cflags lcm`  -g -I . -I../gtest/include
LDFLAGS=`pkg-config --libs lcm`
GTEST_LIBS=../gtest/libgtest.a ../gtest/libgtest_main.a

types1:=exampleconst_t primitives_t primitives_list_t multidim_array_t node_t
types2:=another_type_t cross_package_t
types_src:=$(types1:%=lcmtest/%.hpp) $(types2:%=lcmtest2/%.hpp)

all: client \
	memq_test

common.o: common.cpp $(types_src)
	$(CC) $(CFLAGS) -c $<

client.o: client.cpp $(types_src)
	$(CC) $(CFLAGS) -c $<

client: client.o common.o $(types_src)
	$(CXX) -o $@ client.o common.o $(LDFLAGS) $(GTEST_LIBS)

memq_test: memq_test.o
	$(CXX) -o $@ memq_test.o $(LDFLAGS) $(GTEST_LIBS)

memq_test.o: memq_test.cpp $(types_src)
	$(CXX) $(CFLAGS) -c $<

lcmtest/%.hpp: ../types/lcmtest/%.lcm
	$(LCM_GEN) --cpp $<

lcmtest2/%.hpp: ../types/lcmtest2/%.lcm
	$(LCM_GEN) --cpp $<

clean:
	rm -f client
	rm -f memq_test
	rm -rf lcmtest lcmtest2
	rm -f *.o

=== test/java/Makefile ===
all:
	ant

clean:
	ant clean

=== test/lua/Makefile ===
all:
	lcm-gen -l ../types/lcmtest/*.lcm

clean:
	rm -rf lcmtest

=== test/python/Makefile ===
# This Makefile was tested with GNU Make
LCM_GEN=../../lcmgen/lcm-gen

types:=$(shell ls ../types/*/*.lcm)

all: $(types)
	$(LCM_GEN) --python $(types)

clean:
	rm -rf lcmtest lcmtest2

## lcm 1.3.1%2Brepack1

=== debian/control ===
Source: lcm
Priority: optional
Section: libs
Maintainer: Dima Kogan <dkogan@debian.org>
Build-Depends: debhelper (>= 9), dh-autoreconf,
 libglib2.0-dev, libtool,
 liblua5.2-dev, lua5.2,
 default-jdk-headless | java-sdk, libjchart2d-java, libhamcrest-java, junit,
 doxygen
Standards-Version: 3.9.8
Homepage: http://lcm-proj.github.io/
Vcs-Git: git://anonscm.debian.org/collab-maint/lcm.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/lcm.git

Package: liblcm1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lightweight Communications and Marshalling
 LCM is a set of libraries and tools for message passing and data marshalling,
 targeted at real-time systems where high-bandwidth and low latency are
 critical. It provides a publish/subscribe message passing model and automatic
 marshalling/unmarshalling code generation with bindings for applications in a
 variety of programming languages.
 .
 This package provides the runtime libraries.

Package: liblcm-dev
Architecture: any
Depends: liblcm1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
         liblcm-bin
Description: Lightweight Communications and Marshalling
 LCM is a set of libraries and tools for message passing and data marshalling,
 targeted at real-time systems where high-bandwidth and low latency are
 critical. It provides a publish/subscribe message passing model and automatic
 marshalling/unmarshalling code generation with bindings for applications in a
 variety of programming languages.
 .
 This package provides the runtime libraries.

Package: liblcm-bin
Architecture: any
Depends: liblcm1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Lightweight Communications and Marshalling
 LCM is a set of libraries and tools for message passing and data marshalling,
 targeted at real-time systems where high-bandwidth and low latency are
 critical. It provides a publish/subscribe message passing model and automatic
 marshalling/unmarshalling code generation with bindings for applications in a
 variety of programming languages.
 .
 This package provides the executable tools.

Package: liblcm-lua
Architecture: any
Depends: liblcm1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
         liblcm-bin
Description: Lightweight Communications and Marshalling
 LCM is a set of libraries and tools for message passing and data marshalling,
 targeted at real-time systems where high-bandwidth and low latency are
 critical. It provides a publish/subscribe message passing model and automatic
 marshalling/unmarshalling code generation with bindings for applications in a
 variety of programming languages.
 .
 This package provides the lua interface.

Package: liblcm-java
Architecture: any
Depends: liblcm1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
         liblcm-bin
Description: Lightweight Communications and Marshalling
 LCM is a set of libraries and tools for message passing and data marshalling,
 targeted at real-time systems where high-bandwidth and low latency are
 critical. It provides a publish/subscribe message passing model and automatic
 marshalling/unmarshalling code generation with bindings for applications in a
 variety of programming languages.
 .
 This package provides the java interface.

Package: liblcm-doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lightweight Communications and Marshalling
 LCM is a set of libraries and tools for message passing and data marshalling,
 targeted at real-time systems where high-bandwidth and low latency are
 critical. It provides a publish/subscribe message passing model and automatic
 marshalling/unmarshalling code generation with bindings for applications in a
 variety of programming languages.
 .
 This package contains the documentation

## lcm 1.3.1+repack1

=== debian/changelog ===
lcm (1.3.1+repack1-9) unstable; urgency=medium

  [ Andreas Beckmann ]
  * QA upload.
  * Update watch file.
  * liblcm-doc: Mark as Multi-Arch: same.

  [ Jose Luis Rivero ]
  * Use default-jdk package for java support
  * Add bindnow to DEB_BUILD_MAINT_OPTIONS
  * Fix descriptions

 -- Andreas Beckmann <anbe@debian.org>  Fri, 14 Feb 2025 09:07:26 +0100

lcm (1.3.1+repack1-8) unstable; urgency=medium

  * QA upload.
  * Fix building with -Werror=implicit-function-declaration.
    (Closes: #1066246)

 -- Andreas Beckmann <anbe@debian.org>  Mon, 15 Apr 2024 11:44:58 +0200

lcm (1.3.1+repack1-7) unstable; urgency=medium

  * QA upload.
  * debian/rules: Fix removal of Makefile that contains embedded build
    paths and binary paths. (Closes: #1024286)
  * debian/copyright: Update Source URL.

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Wed, 06 Dec 2023 12:48:38 -0800

lcm (1.3.1+repack1-6) unstable; urgency=medium

  * QA upload.
  * debian/rules: Remove example Makefile that embedded build paths and
    binary paths. (Closes: #1024286)
  * debian/rules: Set Rules-Requires-Root to "no".
  * Update to debhelper-compat 13.

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Fri, 01 Dec 2023 18:34:47 -0800

lcm (1.3.1+repack1-5) unstable; urgency=medium

  * QA upload.
  * Drop liblcm-lua.

 -- Bastian Germann <bage@debian.org>  Sun, 27 Aug 2023 14:22:56 +0200

lcm (1.3.1+repack1-4) unstable; urgency=medium

  * QA upload
  * Move Vcs tags to salsa

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/changelog: Remove trailing whitespaces

 -- Bastian Germann <bage@debian.org>  Mon, 14 Aug 2023 15:09:30 +0200

lcm (1.3.1+repack1-3) unstable; urgency=medium

  * QA upload.
  * Set maintainer to Debian QA Group <packages@qa.debian.org>. (see: #965945)

 -- Marcos Talau <talau@debian.org>  Mon, 14 Nov 2022 08:12:48 -0300

lcm (1.3.1+repack1-2.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Fixed the build failure with Java 17 (Closes: #982044)

 -- Emmanuel Bourg <ebourg@apache.org>  Mon, 16 May 2022 23:52:19 +0200

lcm (1.3.1+repack1-2.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove the Python2 bindings. (Closes: #936829)

 -- Adrian Bunk <bunk@debian.org>  Tue, 24 Dec 2019 07:22:19 +0200

lcm (1.3.1+repack1-2.2) unstable; urgency=medium

  * Replace previous NMU with a new source-only upload.

 -- Kenneth J. Pronovici <pronovic@debian.org>  Thu, 08 Aug 2019 02:19:29 +0000

lcm (1.3.1+repack1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Eliminate dependency on epydoc, which will be removed (closes: #881547)
    - Update debian/control to remove Build-Depends: python-epydoc
    - Update docs/build-docs.sh so it no longer builds epydoc documentation

 -- Kenneth J. Pronovici <pronovic@debian.org>  Fri, 02 Aug 2019 15:42:31 +0000

lcm (1.3.1+repack1-2) unstable; urgency=medium

  * I default to java 1.6, not java 1.5 (Closes: #893552)

 -- Dima Kogan <dkogan@debian.org>  Sat, 31 Mar 2018 01:46:28 -0700

lcm (1.3.1+repack1-1) unstable; urgency=medium

    Initial release (Closes: #577848)

 -- Dima Kogan <dkogan@debian.org>  Sun, 09 Oct 2016 01:27:18 -0700

=== debian/control ===
Source: lcm
Priority: optional
Section: libs
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 debhelper-compat (= 13),
 default-jdk,
 doxygen,
 junit,
 libglib2.0-dev,
 libhamcrest-java,
 libjchart2d-java,
 libtool,
Standards-Version: 3.9.8
Homepage: http://lcm-proj.github.io/
Vcs-Git: https://salsa.debian.org/debian/lcm.git
Vcs-Browser: https://salsa.debian.org/debian/lcm
Rules-Requires-Root: no

Package: liblcm1
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Lightweight Communications and Marshalling - Runtime lib
 LCM is a set of libraries and tools for message passing and data marshalling,
 targeted at real-time systems where high-bandwidth and low latency are
 critical. It provides a publish/subscribe message passing model and automatic
 marshalling/unmarshalling code generation with bindings for applications in a
 variety of programming languages.
 .
 This package provides the runtime libraries.

Package: liblcm-dev
Section: libdevel
Architecture: any
Depends:
 liblcm-bin,
 liblcm1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Lightweight Communications and Marshalling - Dev files
 LCM is a set of libraries and tools for message passing and data marshalling,
 targeted at real-time systems where high-bandwidth and low latency are
 critical. It provides a publish/subscribe message passing model and automatic
 marshalling/unmarshalling code generation with bindings for applications in a
 variety of programming languages.
 .
 This package provides the development files.

Package: liblcm-bin
Architecture: any
Depends:
 liblcm1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Lightweight Communications and Marshalling - Executable tools
 LCM is a set of libraries and tools for message passing and data marshalling,
 targeted at real-time systems where high-bandwidth and low latency are
 critical. It provides a publish/subscribe message passing model and automatic
 marshalling/unmarshalling code generation with bindings for applications in a
 variety of programming languages.
 .
 This package provides the executable tools.

Package: liblcm-java
Section: java
Architecture: any
Depends:
 liblcm-bin,
 liblcm1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Lightweight Communications and Marshalling - Java Interface
 LCM is a set of libraries and tools for message passing and data marshalling,
 targeted at real-time systems where high-bandwidth and low latency are
 critical. It provides a publish/subscribe message passing model and automatic
 marshalling/unmarshalling code generation with bindings for applications in a
 variety of programming languages.
 .
 This package provides the Java interface.

Package: liblcm-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Lightweight Communications and Marshalling - Documentation
 LCM is a set of libraries and tools for message passing and data marshalling,
 targeted at real-time systems where high-bandwidth and low latency are
 critical. It provides a publish/subscribe message passing model and automatic
 marshalling/unmarshalling code generation with bindings for applications in a
 variety of programming languages.
 .
 This package contains the documentation.

=== debian/watch ===
version=4
opts="dversionmangle=s/\+repack.*$//, \
      uversionmangle=s/-RC/~rc/, \
      filenamemangle=s%(?:.*?)?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
  https://github.com/lcm-proj/lcm/tags \
  (?:.*?/)?@ANY_VERSION@@ARCHIVE_EXT@

## lcm 1.5.0~repack1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

if(POLICY CMP0111)
  cmake_policy(SET CMP0111 NEW)
endif()

project(lcm)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
if(CMAKE_VERSION VERSION_LESS 3.7)
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/3.7")
endif()

find_package(GLib2 REQUIRED)

# Configuration and utility functions
include(lcm-cmake/config.cmake NO_POLICY_SCOPE)
include(lcm-cmake/functions.cmake)
include(lcm-cmake/version.cmake)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Set CMAKE_MACOSX_RPATH on macOS to satisfy policy CMP0042.
if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(CMAKE_MACOSX_RPATH FALSE)
endif()

# Core modules
add_subdirectory(lcm)
add_subdirectory(lcmgen)
add_subdirectory(lcm-logger)

option(LCM_ENABLE_EXAMPLES "Build test and example programs" ON)
if(LCM_ENABLE_EXAMPLES)
  add_subdirectory(liblcm-test)
endif()

# Python
lcm_option(
  LCM_ENABLE_PYTHON
  "Build Python bindings and utilities"
  PYTHON_FOUND Python)
if(LCM_ENABLE_PYTHON)
  add_subdirectory(lcm-python)
endif()

# Documentation (Main, C/C++, .NET)
add_subdirectory(docs)

# Java
lcm_option(
  LCM_ENABLE_JAVA
  "Build Java bindings and utilities"
  JAVA_FOUND Java 1.8)
if(LCM_ENABLE_JAVA)
  add_subdirectory(lcm-java)
  add_custom_target(lcm-spy DEPENDS lcm-spy-alias)
  add_custom_target(lcm-logplayer-gui DEPENDS lcm-logplayer-gui-alias)
endif()

# Lua
lcm_option(
  LCM_ENABLE_LUA
  "Build Lua bindings and utilities"
  LUA_FOUND Lua)
if(LCM_ENABLE_LUA)
  add_subdirectory(lcm-lua)
endif()

# .NET
# TODO

# Go
lcm_option(
  LCM_ENABLE_GO
  "Build Go utilities, bindings is source distributed"

  # Disable until #294 is resolved
  FALSE Go)
  #  GO_FOUND Go)

option(LCM_ENABLE_TESTS "Build unit tests" ON)
if(LCM_ENABLE_TESTS)
  enable_testing()
  add_subdirectory(test)
endif()

# Install rules
include(lcm-cmake/install.cmake)

option(LCM_INSTALL_M4MACROS "Install autotools support M4 macros" ON)
if(LCM_INSTALL_M4MACROS)
  add_subdirectory(m4macros)
endif()

option(LCM_INSTALL_PKGCONFIG "Install pkg-config files" ON)
if(LCM_INSTALL_PKGCONFIG)
  add_subdirectory(lcm-pkgconfig)
endif()

# Distribution rules
add_custom_target(dist
  COMMAND ${CMAKE_COMMAND}
    -DSOURCE_DIR=${lcm_SOURCE_DIR}
    -DOUTPUT_DIR=${lcm_BINARY_DIR}
    -DVERSION=${LCM_VERSION}
    -P ${lcm_SOURCE_DIR}/lcm-cmake/mkdist.cmake)

# CPack packaging rules
include(lcm-cmake/cpack.cmake)

=== docs/CMakeLists.txt ===
add_custom_target(doc)

find_program(DOXYGEN_EXECUTABLE doxygen)
if(NOT DOXYGEN_EXECUTABLE)
  message(WARNING
    "Doxygen was not found; documentation generation will be incomplete")
  return()
endif()

set(BUILD_DIR ${lcm_BINARY_DIR})

configure_file(
  ${lcm_SOURCE_DIR}/docs/Doxyfile.in
  ${lcm_BINARY_DIR}/docs/Doxyfile
  @ONLY)

configure_file(
  ${lcm_SOURCE_DIR}/lcm-dotnet/Doxyfile.in
  ${lcm_BINARY_DIR}/lcm-dotnet/Doxyfile
  @ONLY)

add_custom_target(doc-clean
  COMMAND ${CMAKE_COMMAND} -E remove_directory ${lcm_BINARY_DIR}/docs/_build)

add_custom_target(doc-setup
  COMMAND ${CMAKE_COMMAND} -E make_directory ${lcm_BINARY_DIR}/docs/_build/
  DEPENDS doc-clean)

add_custom_target(doc-doxygen
  COMMAND ${CMAKE_COMMAND} -E make_directory ${lcm_BINARY_DIR}/docs/_build/doxygen_output/
  COMMAND ${DOXYGEN_EXECUTABLE} ${lcm_BINARY_DIR}/docs/Doxyfile
  COMMAND ${CMAKE_COMMAND} -E copy
          ${lcm_SOURCE_DIR}/docs/redirect.html
          ${lcm_BINARY_DIR}/docs/_build/doxygen_output/c_cpp/html/index.html
  WORKING_DIRECTORY ${lcm_SOURCE_DIR}/docs
  DEPENDS doc-setup doc-sphinx)

add_custom_target(doc-dotnet
  COMMAND ${CMAKE_COMMAND} -E make_directory ${lcm_BINARY_DIR}/docs/_build/doxygen_output/
  COMMAND ${DOXYGEN_EXECUTABLE} ${lcm_BINARY_DIR}/lcm-dotnet/Doxyfile
  COMMAND ${CMAKE_COMMAND} -E copy
          ${lcm_SOURCE_DIR}/docs/redirect.html
          ${lcm_BINARY_DIR}/docs/_build/doxygen_output/lcm-dotnet/html/index.html
  WORKING_DIRECTORY ${lcm_SOURCE_DIR}/lcm-dotnet
  DEPENDS doc-setup doc-doxygen)

find_program(SPHINX_EXECUTABLE sphinx-build)
if(NOT SPHINX_EXECUTABLE)
  message(WARNING
    "Sphinx was not found; documentation generation will be incomplete")
  return()
endif()

add_custom_target(doc-sphinx
  COMMAND "PYTHONPATH=${CMAKE_BINARY_DIR}/python" ${SPHINX_EXECUTABLE} ${lcm_SOURCE_DIR}/docs ${lcm_BINARY_DIR}/docs/_build
  WORKING_DIRECTORY ${lcm_SOURCE_DIR}/docs
  DEPENDS doc-setup lcm-python lcm-python-init)

add_dependencies(doc doc-dotnet doc-doxygen)

=== lcm-java/CMakeLists.txt ===
include(UseJava)

if (Java_VERSION VERSION_GREATER 1.9 OR Java_VERSION VERSION_EQUAL 1.9)
  set(LCM_JAVA_TARGET_VERSION "8" CACHE STRING
    "Java version to target when building Java components (leave empty to use default)"
  )
  if(NOT LCM_JAVA_TARGET_VERSION STREQUAL "")
    set(CMAKE_JAVA_COMPILE_FLAGS
      --release ${LCM_JAVA_TARGET_VERSION}
    )
  endif()
elseif (Java_VERSION VERSION_LESS 1.9)
  set(LCM_JAVA_TARGET_VERSION "1.8" CACHE STRING
    "Java version to target when building Java components (leave empty to use default)"
  )
  if(NOT LCM_JAVA_TARGET_VERSION STREQUAL "")
    set(CMAKE_JAVA_COMPILE_FLAGS
      -source ${LCM_JAVA_TARGET_VERSION}
      -target ${LCM_JAVA_TARGET_VERSION}
    )
  endif()
endif()

add_subdirectory(jchart2d-code)

set(lcm_java_sources
  lcm/util/JImage.java
  lcm/util/TableSorter.java
  lcm/util/BufferedRandomAccessFile.java
  lcm/util/ParameterListener.java
  lcm/util/ParameterGUI.java
  lcm/util/ClassDiscoverer.java
  lcm/util/ColorMapper.java
  lcm/spy/Spy.java
  lcm/spy/ObjectPanel.java
  lcm/spy/ChartData.java
  lcm/spy/ChannelData.java
  lcm/spy/ZoomableChartScrollWheel.java
  lcm/spy/SpyPlugin.java
  lcm/spy/LCMTypeDatabase.java
  lcm/logging/LogDiagnostic.java
  lcm/logging/JScrubber.java
  lcm/logging/JScrubberListener.java
  lcm/logging/Log.java
  lcm/logging/LogPlayer.java
  lcm/lcm/LCMDataOutputStream.java
  lcm/lcm/Provider.java
  lcm/lcm/LCMDataInputStream.java
  lcm/lcm/UDPMulticastProvider.java
  lcm/lcm/LCMSubscriber.java
  lcm/lcm/URLParser.java
  lcm/lcm/MessageAggregator.java
  lcm/lcm/MemqProvider.java
  lcm/lcm/LCMEncodable.java
  lcm/lcm/LCM.java
  lcm/lcm/LogFileProvider.java
  lcm/lcm/TCPProvider.java
  lcm/lcm/TCPService.java
)

add_jar(lcm-java
  INCLUDE_JARS jchart2d
  SOURCES ${lcm_java_sources}
  OUTPUT_NAME lcm
)

install_jar(lcm-java DESTINATION share/java)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/lcm-spy.sh.in
  ${CMAKE_CURRENT_BINARY_DIR}/lcm-spy
  @ONLY
)

lcm_copy_file_target(lcm-logplayer-gui-alias
  ${CMAKE_CURRENT_SOURCE_DIR}/lcm-logplayer-gui.sh
  ${CMAKE_CURRENT_BINARY_DIR}/lcm-logplayer-gui
)

install(PROGRAMS
  ${CMAKE_CURRENT_BINARY_DIR}/lcm-logplayer-gui
  ${CMAKE_CURRENT_BINARY_DIR}/lcm-spy
  DESTINATION bin
)

install(FILES
  lcm-logplayer-gui.1
  lcm-spy.1
  DESTINATION share/man/man1
)

if(NOT Java_JAVADOC_EXECUTABLE)
  message(WARNING
    "javadoc was not found; Java documentation will not be generated")
  return()
endif()

set(lcm_java_doc_classes
  lcm/lcm/LCM.java
  lcm/lcm/LCMEncodable.java
  lcm/lcm/LCMSubscriber.java
  lcm/lcm/MessageAggregator.java
  lcm/logging/Log.java
)

add_custom_target(doc-java
  COMMAND  ${Java_JAVADOC_EXECUTABLE}
    -d ${lcm_BINARY_DIR}/docs/_build/javadocs
    -link http://docs.oracle.com/javase/8/docs/api/
    ${lcm_java_doc_classes}
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS doc-setup doc-sphinx)

add_dependencies(doc doc-java)

=== lcm-logger/CMakeLists.txt ===
add_executable(lcm-logger lcm_logger.c glib_util.c)
target_link_libraries(lcm-logger lcm GLib2::glib)

add_executable(lcm-logplayer lcm_logplayer.c)
target_link_libraries(lcm-logplayer lcm GLib2::glib)

install(TARGETS
  lcm-logger
  lcm-logplayer
  DESTINATION bin
)

install(FILES
  lcm-logger.1
  lcm-logplayer.1
  DESTINATION share/man/man1
)

=== lcm-lua/CMakeLists.txt ===
set(lcm_lua_sources
  init.c
  lualcm_hash.c
  lualcm_lcm.c
  lualcm_pack.c
  lua_ref_helper.c
  utf8_check.c
)

add_library(lcm-lua MODULE ${lcm_lua_sources})
set_target_properties(lcm-lua PROPERTIES OUTPUT_NAME "lcm" PREFIX "")
target_compile_options(lcm-lua PRIVATE -Werror -Wall -Wextra)

target_include_directories(lcm-lua PRIVATE
  ${LUA_INCLUDE_DIR}
)

target_link_libraries(lcm-lua lcm ${LUA_LIBRARY})

install(TARGETS lcm-lua
  DESTINATION lib${LIB_SUFFIX}/lua/${LUA_VERSION_MAJOR}.${LUA_VERSION_MINOR}
)

=== lcm-pkgconfig/CMakeLists.txt ===
file(TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}" LCM_INSTALL_PREFIX)

configure_file(lcm.pc.in ${lcm_BINARY_DIR}/lcm.pc @ONLY)
install(FILES ${lcm_BINARY_DIR}/lcm.pc
  DESTINATION lib${LIB_SUFFIX}/pkgconfig)

if(LCM_ENABLE_JAVA)
  configure_file(lcm-java.pc.in ${lcm_BINARY_DIR}/lcm-java.pc @ONLY)
  install(FILES ${lcm_BINARY_DIR}/lcm-java.pc
    DESTINATION lib${LIB_SUFFIX}/pkgconfig)
endif()

=== lcm-python/CMakeLists.txt ===
# FindPython added in 3.12
cmake_minimum_required(VERSION 3.12)

execute_process(
  COMMAND "${Python_EXECUTABLE}" -c "if True:
    from sysconfig import get_path
    from os.path import sep
    print(get_path('platlib').replace(get_path('data') + sep, ''))"
  OUTPUT_VARIABLE PYTHON_SITE
  OUTPUT_STRIP_TRAILING_WHITESPACE)

set(lcm_python_sources
  module.c
  pyeventlog.c
  pylcm.c
  pylcm_subscription.c
)

add_library(lcm-python MODULE ${lcm_python_sources})

set_target_properties(lcm-python PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/python/lcm
  LIBRARY_OUTPUT_NAME _lcm
  PREFIX ""
)

if (WIN32 AND NOT CYGWIN)
  set_target_properties(lcm-python PROPERTIES SUFFIX .pyd)
endif ()

find_package (Python COMPONENTS Interpreter Development)

target_include_directories(lcm-python PRIVATE
  ${Python_INCLUDE_DIRS}
)

target_link_libraries(lcm-python PRIVATE
  lcm-static
)

if(APPLE)
  set_target_properties(lcm-python PROPERTIES LINK_FLAGS "-undefined dynamic_lookup -Wl,-no_fixup_chains")
else()
  target_link_libraries(lcm-python PRIVATE
    ${Python_LIBRARIES}
  )
endif()

install(TARGETS lcm-python
  RUNTIME DESTINATION ${PYTHON_SITE}/lcm
  LIBRARY DESTINATION ${PYTHON_SITE}/lcm
)

lcm_copy_file_target(lcm-python-init
  ${CMAKE_CURRENT_SOURCE_DIR}/lcm/__init__.py
  ${CMAKE_BINARY_DIR}/python/lcm/__init__.py
)

install(FILES lcm/__init__.py DESTINATION ${PYTHON_SITE}/lcm)

=== lcm/CMakeLists.txt ===
if(UNIX)
  find_package(Threads)
endif()

set(lcm_sources
  eventlog.c
  lcm.c
  lcm_file.c
  lcm_memq.c
  lcm_mpudpm.c
  lcm_tcpq.c
  lcm_udpm.c
  ringbuffer.c
  udpm_util.c
  lcmtypes/channel_port_map_update_t.c
  lcmtypes/channel_to_port_t.c
)

set(lcm_install_headers
  eventlog.h
  lcm.h
  lcm_coretypes.h
  lcm_version.h
  lcm-cpp.hpp
  lcm-cpp-impl.hpp
  ${CMAKE_CURRENT_BINARY_DIR}/lcm_export.h
)

if(WIN32)
  list(APPEND lcm_sources
    windows/WinLCM.cpp
    windows/WinPorting.cpp
  )
  list(APPEND lcm_install_headers
    windows/WinPorting.h
  )
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

add_library(lcm-coretypes INTERFACE)
add_library(lcm-static STATIC ${lcm_sources})
add_library(lcm SHARED ${lcm_sources})

foreach(lcm_lib lcm lcm-static)
  target_compile_definitions(${lcm_lib} PRIVATE
    _FILE_OFFSET_BITS=64
    _LARGEFILE_SOURCE
    _REENTRANT
  )

  set_target_properties(${lcm_lib} PROPERTIES
    VERSION ${LCM_VERSION}
    SOVERSION ${LCM_ABI_VERSION}
    PUBLIC_HEADER "${lcm_install_headers}"
  )

  target_include_directories(${lcm_lib} INTERFACE
    $<BUILD_INTERFACE:${lcm_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  )

  target_link_libraries(${lcm_lib} PRIVATE
    GLib2::glib
    ${CMAKE_THREAD_LIBS_INIT}
  )

  if(WIN32)
    target_link_libraries(${lcm_lib} PRIVATE wsock32 ws2_32)
  endif()
endforeach()

generate_export_header(lcm STATIC_DEFINE LCM_STATIC)

target_compile_definitions(lcm-static PUBLIC LCM_STATIC)
if(NOT WIN32)
  set_target_properties(lcm-static PROPERTIES OUTPUT_NAME lcm)
endif()

target_include_directories(lcm-coretypes INTERFACE
  $<BUILD_INTERFACE:${lcm_SOURCE_DIR}>
)

install(TARGETS lcm-coretypes lcm-static lcm
  EXPORT lcmTargets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib${LIB_SUFFIX}
  ARCHIVE DESTINATION lib${LIB_SUFFIX}
  PUBLIC_HEADER DESTINATION include/lcm
  INCLUDES DESTINATION include
)

=== lcmgen/CMakeLists.txt ===
set(lcm-gen_sources
  emit_c.c
  emit_csharp.c
  emit_cpp.c
  emit_go.c
  emit_java.c
  emit_lua.c
  emit_python.c
  getopt.c
  getopt.h
  lcmgen.c
  lcmgen.h
  main.c
  tokenize.c
  tokenize.h
)

include(CMakeDependentOption)
set(_uses_sanitizers OFF)
if("${CMAKE_C_FLAGS} ${CMAKE_CXX_FLAGS}" MATCHES "-fsanitize[=-][^ ;]*")
  set(_uses_sanitizers ON)
endif()

cmake_dependent_option(LCM_SANITIZE_LCMGEN
  "Enable sanitizers when building lcmgen (may cause lcmgen failures)"
  OFF "_uses_sanitizers" OFF)
mark_as_advanced(LCM_SANITIZE_LCMGEN)

if(_uses_sanitizers AND NOT LCM_SANITIZE_LCMGEN)
  message(WARNING
    "It looks like you are building LCM with -fsanitize. This may cause lcmgen"
    " to exit with a non-zero result triggered by the sanitizers detecting"
    " known (harmless) memory leaks, which in turn may cause build systems to"
    " spuriously believe that lcmgen has failed. Since you probably don't want"
    " that, we are disabling sanitizers for lcmgen.\n"
    "To override this behavior, set LCM_SANITIZE_LCMGEN to ON."
  )
  macro(strip_flag FLAG VAR)
    string(REGEX REPLACE "${FLAG}" "" ${VAR} "${${VAR}}")
  endmacro()
  strip_flag("-fsanitize[=-][^ ;]*" CMAKE_C_FLAGS)
  strip_flag("-fsanitize[=-][^ ;]*" CMAKE_EXE_LINKER_FLAGS)
endif()

add_executable(lcm-gen ${lcm-gen_sources})
target_link_libraries(lcm-gen PRIVATE GLib2::glib)

install(TARGETS lcm-gen
  EXPORT lcmTargets
  RUNTIME DESTINATION bin
)

install(FILES lcm-gen.1 DESTINATION share/man/man1)

=== liblcm-test/CMakeLists.txt ===
add_executable(lcm-sink lcm-sink.c)
target_link_libraries(lcm-sink lcm)

add_executable(lcm-source lcm-source.c)
target_link_libraries(lcm-source lcm)

add_executable(lcm-tester lcm-tester.c)
target_link_libraries(lcm-tester lcm GLib2::glib)
if(WIN32)
  target_link_libraries(lcm-tester wsock32 ws2_32)
endif()

add_executable(lcm-example lcm-example.c)
target_link_libraries(lcm-example lcm)
if(WIN32)
  target_link_libraries(lcm-example ws2_32)
endif()

add_executable(lcm-logfilter lcm-logfilter.c)
target_link_libraries(lcm-logfilter lcm GLib2::glib)

add_executable(lcm-buftest-receiver buftest-receiver.c)
target_link_libraries(lcm-buftest-receiver lcm GLib2::glib)

add_executable(lcm-buftest-sender buftest-sender.c)
target_link_libraries(lcm-buftest-sender lcm GLib2::glib)

install(TARGETS
  lcm-sink
  lcm-source
  lcm-tester
  lcm-example
  lcm-logfilter
  DESTINATION bin
)

install(FILES
  lcm-example.1
  lcm-sink.1
  lcm-source.1
  lcm-tester.1
  DESTINATION share/man/man1
)

=== m4macros/CMakeLists.txt ===
install(FILES lcm.m4 DESTINATION share/aclocal)

=== test/CMakeLists.txt ===
add_subdirectory(gtest)

add_subdirectory(types)

add_subdirectory(c)
add_subdirectory(cpp)

if(LCM_ENABLE_PYTHON)
  add_subdirectory(python)
endif()

if(LCM_ENABLE_JAVA)
  add_subdirectory(java)
endif()

if(LCM_ENABLE_LUA)
  add_subdirectory(lua)
endif()

if(LCM_ENABLE_GO)
  add_subdirectory(go)
endif()

=== debian/changelog ===
lcm (1.5.0~repack1-0ubuntu2) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 12:05:07 +0100

lcm (1.5.0~repack1-0ubuntu1) noble; urgency=medium

  [ Jose Luis Rivero ]
  * New upstream version 1.5.0~repack
    (LP: #1956368, #2053256)
  * Formatter changes
  * Bump standards to 4.6.2 (no changes needed)
  * Use default-jdk package for java support
  * Bump version to 1.5.0~repack1
  * Rediff patches:
  * PATCH: use gnuinstalldirs in CMake
  * PATCH: use gtest from system
  * PATCH: use java system dependencies instead of embedded files
  * PATCH: Encode utf8 characters to fix the java build
  * PATCH: fix manpages name to make lintian happy
  * Add CMake to d/control
  * Use --no-parallel for testing
  * Cleanup d/rules
  * Update liblcm-doc.docs for new paths
  * Generalize d/liblcm-dev.install
  * Convert package to use pybuild. Change d/rules heavily.
  * Update java dependencies in d/control
  * Update d/copyright file
  * Keep lcm-java.pc only in the java package
  * Remove .doctrees from the -docs package
  * Add bindnow to DEB_BUILD_MAINT_OPTIONS
  * Replace embedded fonts and jquery with system dependencies
  * Remove .gitignore from liblcm-doc installation
  * Update existing patch for javadoc generation
  * Rework java patch to use offline generation
  * Reorder java dependencies: in -bin and -java
  * Adding Section: to packages
  * Added autotest: install and build-cpp

  [ Vladimir Petko ]
  * Use javahelper to package jar file
  * PATCH: fix build error due to the quotes around pythonpath

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 10 Apr 2024 13:28:38 +0200

lcm (1.3.1+repack1-7build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 01:38:35 +0000

lcm (1.3.1+repack1-7build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:17:22 +0000

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/java/java_defaults.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export PYBUILD_SYSTEM=cmake
export PYBUILD_CONFIGURE_ARGS=-DLCM_JAVA_TARGET_VERSION=$(java_compat_level) \
                              -DCMAKE_JAVA_COMPILE_FLAGS=-g

%:
	dh $@ --with=sphinxdoc --with=javahelper --buildsystem=pybuild

execute_after_dh_auto_build-indep:
	$(MAKE) -C `pybuild --print build_dir --interpreter python3` doc
	$(RM) -fr `pybuild --print build_dir --interpreter python3`/docs/_build/.doctrees

# Tests exercise the passing of messages and are broken if
# several of them are run in parallel
override_dh_auto_test:
	PYBUILD_SYSTEM=custom \
		PYBUILD_TEST_ARGS="dh_auto_test --no-parallel --buildsystem=cmake --builddirectory={build_dir}" dh_auto_test

# Leave the pkg-config file in the java package
execute_after_dh_install:
	$(RM) debian/liblcm-java/usr/lib/pkgconfig/lcm-java.pc

execute_after_dh_installdocs:
	$(RM) debian/liblcm-doc/usr/share/doc/liblcm-dev/examples/.gitignore

override_dh_auto_clean:
	dh_auto_clean
	rm -rf docs/_build

=== debian/tests/control ===
Tests: install
Depends: liblcm-bin
Restrictions: allow-stderr, superficial

Tests: build-cpp-example
Depends: cmake, build-essential, liblcm-doc, liblcm-dev
Restrictions: allow-stderr, superficial
